## whoopsie 0.2.0

=== Makefile ===
VERSION=$(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2)
CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) $(shell libgcrypt-config --cflags) -g -Ilib -Wall -Werror -Os -DVERSION=\"$(VERSION)\"
LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) $(shell libgcrypt-config --libs) -lcap
SOURCES=src/whoopsie.c \
		src/utils.c \
		src/connectivity.c \
		src/monitor.c \
		src/identifier.c \
		lib/bson/bson.c \
		lib/bson/encoding.c \
		lib/bson/numbers.c
OBJECTS=$(SOURCES:.c=.o)
EXECUTABLE=src/whoopsie
BIN=$(DESTDIR)/usr/bin
DATA=$(DESTDIR)/etc

.PHONY: all clean check install

all: $(SOURCES) $(EXECUTABLE)

$(EXECUTABLE): $(OBJECTS)
	c99 $(OBJECTS) $(LIBS) -o $@
clean:
	rm -f $(EXECUTABLE) $(OBJECTS)
	$(MAKE) -C src/tests clean
check:
	$(MAKE) -C src/tests
	if type cppcheck >/dev/null 2>&1; then \
		cppcheck . --error-exitcode=1; \
	fi
	find -name "*.py" -o -name "*.wsgi" | xargs pyflakes
coverage:
	$(MAKE) -C src/tests coverage
%.o: %.c
	c99 -c $(CFLAGS) -o $@ $^

install: all
	install -d $(BIN)
	install src/whoopsie $(BIN)
	install -d $(DATA)/init
	install -m644 data/whoopsie.conf $(DATA)/init
	install -d $(DATA)/default
	install -m644 data/whoopsie $(DATA)/default
	install -d $(DESTDIR)/usr/share/apport/package-hooks
	install -m644 data/whoopsie.py $(DESTDIR)/usr/share/apport/package-hooks

=== src/tests/Makefile ===
VERSION=$(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2)
CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
		$(shell libgcrypt-config --cflags) \
		-g -I../../lib -I.. -DVERSION=\"$(VERSION)\" -DTEST -DTEST_DIR=\"$(CURDIR)\" -Wall
LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
		$(shell libgcrypt-config --libs)

test_parse_report_SOURCES=test_parse_report.c \
							../whoopsie.c \
							../utils.c \
							../identifier.c \
							../../lib/bson/bson.c \
							../../lib/bson/encoding.c \
							../../lib/bson/numbers.c
test_parse_report_EXECUTABLE=test_parse_report
test_parse_report_OBJECTS=$(test_parse_report_SOURCES:.c=.test.o)

test_utils_SOURCES=test_utils.c \
					../utils.c
test_utils_EXECUTABLE=test_utils
test_utils_OBJECTS=$(test_utils_SOURCES:.c=.test.o)

test_monitor_SOURCES=test_monitor.c \
					../monitor.c \
					../utils.c
test_monitor_EXECUTABLE=test_monitor
test_monitor_OBJECTS=$(test_monitor_SOURCES:.c=.test.o)

test_identifier_SOURCES=test_identifier.c \
					../identifier.c
test_identifier_EXECUTABLE=test_identifier
test_identifier_OBJECTS=$(test_identifier_SOURCES:.c=.test.o)

.PHONY: all clean check

all: check

check: $(test_parse_report_EXECUTABLE) $(test_utils_EXECUTABLE) $(test_monitor_EXECUTABLE) $(test_identifier_EXECUTABLE)
	$(foreach p, $^, ./$p -k;)

$(test_parse_report_EXECUTABLE): $(test_parse_report_OBJECTS)
	c99 $^ $(LIBS) -o $@
$(test_utils_EXECUTABLE): $(test_utils_OBJECTS)
	c99 $^ $(LIBS) -o $@
$(test_monitor_EXECUTABLE): $(test_monitor_OBJECTS)
	c99 $^ $(LIBS) -o $@
$(test_identifier_EXECUTABLE): $(test_identifier_OBJECTS)
	c99 $^ $(LIBS) -o $@

test_parse_report_coverage: $(test_parse_report_OBJECTS:.test.o=.coverage.o)
	c99 $^ $(LIBS) -lgcov -o $@
test_utils_coverage: $(test_utils_OBJECTS:.test.o=.coverage.o)
	c99 $^ $(LIBS) -lgcov -o $@
test_monitor_coverage: $(test_monitor_OBJECTS:.test.o=.coverage.o)
	c99 $^ $(LIBS) -lgcov -o $@
test_identifier_coverage: $(test_identifier_OBJECTS:.test.o=.coverage.o)
	c99 $^ $(LIBS) -lgcov -o $@
coverage: test_parse_report_coverage test_utils_coverage test_monitor_coverage test_identifier_coverage
	$(foreach p, $^, ./$p -k;)
	$(foreach p, $(wildcard ../*.c), gcov $p -o $(p:.c=.coverage.o);)

clean:
	rm -f $(test_parse_report_EXECUTABLE) \
		$(test_parse_report_OBJECTS) \
		$(test_utils_OBJECTS) \
		$(test_utils_EXECUTABLE) \
		$(test_monitor_OBJECTS) \
		$(test_monitor_EXECUTABLE) \
		$(test_identifier_OBJECTS) \
		$(test_identifier_EXECUTABLE) \
		test_parse_report_coverage \
		test_utils_coverage \
		test_identifier_coverage \
		coverage
	find ../.. \( -name '*.coverage.o' -o \
		-name '*.gcda' -o \
		-name '*.gcno' -o \
		-name '*.gcov' \) -delete

%.coverage.o: %.c
	c99 -c -o $@ $^ $(CFLAGS) --coverage -O0
%.test.o: %.c
	c99 -c -o $@ $^ $(CFLAGS)

=== debian/changelog ===
whoopsie (0.2.0) quantal; urgency=low

  * Create the /var/metrics directory for metrics submission. Thanks Ted
    Gould.
  * Fallback to using the SHA-512 hash of the first non-loopback MAC
    address (LP: #963007, LP: #959308).

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 14 Jun 2012 20:57:31 +0100

whoopsie-daisy (0.1.32) precise; urgency=low

  * Fix failing tests on powerpc and ARM.

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 18 Apr 2012 13:04:36 +0100

whoopsie-daisy (0.1.31) precise; urgency=low

  * == is a bashism.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 12 Apr 2012 15:06:11 +0100

whoopsie-daisy (0.1.30) precise; urgency=low

  * Stop rejecting legal arguments to the postinst (LP: #978436). Thanks
    Colin Watson!

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 12 Apr 2012 09:00:26 +0100

whoopsie-daisy (0.1.29) precise; urgency=low

  * Mark reports as complete when we get a HTTP response of 400 from the
    server, as these represent the server not liking what we sent it.
    Sending these again repeatedly would be pointless (LP: #979082). 

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 11 Apr 2012 17:36:32 +0100

whoopsie-daisy (0.1.28) precise; urgency=low

  * Create /var/crash if it doesn't already exist. Don't silence the
    chmod and chgrp calls on it. Thanks Colin Watson (LP: #978502)!

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 11 Apr 2012 09:44:12 +0100

whoopsie-daisy (0.1.27) precise; urgency=low

  * Drop /etc/cron.daily/whoopsie. This is handled in apport now.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 10 Apr 2012 18:01:02 +0100

whoopsie-daisy (0.1.26) precise; urgency=low

  * Take ownership of the NetworkManager state variant on setup and
    unref it, plugging a memory leak.
  * Log the reason the server rejected the submitted crash report.
  * Send the Whoopsie version with each crash submission.
  * Delete both .upload and .uploaded files after 14 days. Thanks
    Marc Deslauriers (LP: #973687).

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 10 Apr 2012 14:28:58 +0100

whoopsie-daisy (0.1.25) precise; urgency=low

  * Stop using a queue to monitor reports that need to be processed.
    Just iterate over the reports that have a .upload file, but do not
    have a matching .uploaded file.
  * Set the GSettings backend to memory to avoid pulling in DConf when
    we call into GNetworkMonitor.
  * Split out the /var/crash monitoring code and add tests for it.
  * Plug some memory leaks.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 29 Mar 2012 23:30:39 +0100

whoopsie-daisy (0.1.24) precise; urgency=low

  * Add the file listing of /var/crash to whoopsie bug reports. Taken
    from apport's package hook.
  * Fix cppcheck call in make check.
  * Monitor network connectivity using NetworkManager and GNetworkMonitor.
    Do not report being online and able to report crashes if the user only
    has 3G or dial-up connectivity, or if there is no route.
  * Do not upload crashes multiple times if the file attributes for
    their .upload files change while on the report queue.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 29 Mar 2012 11:37:51 +0100

whoopsie-daisy (0.1.23) precise; urgency=low

  * Fix builds failing when cppcheck isn't present.
  * Clean up closing file descriptors in mark_handled. Thanks Colin
    Watson.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 23 Mar 2012 14:43:41 +0000

whoopsie-daisy (0.1.22) precise; urgency=low

  * Do not leak the file descriptor of our lockfile.
  * Do not leak a file descriptor when marking a report as handled. Add
    a test for the mark_report function.
  * Fix potential NULL pointer dereference in report tests.
  * If allocated with g_malloc, free with g_free.
  * Add cppcheck to make check, but only when it's installed.
  * Plug a memory corruption bug (hopefully). g_queue_find_custom
    returns a *link* not a list, so do not try to hand it back to the
    slice allocator as if it were a list.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 23 Mar 2012 14:17:43 +0000

whoopsie-daisy (0.1.21) precise; urgency=low

  [ Steve Langasek ]
  * debian/rules: make sure dh_installinit knows about our upstart job, so
    we get correct start/stop/restart handling on install/removal/upgrade.

  [ Evan Dandrea ]
  * Disable the network detection for now, to help in tracking the
    source of a memory corruption bug.
  * Clean up option parsing a bit.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 23 Mar 2012 11:44:51 +0000

whoopsie-daisy (0.1.20) precise; urgency=low

  * Handle errors in changing the filename extension, even when we're
    pretty sure we have an extension.
  * Handle errors in g_file_get_path.
  * CURLOPT_WRITEFUNCTION may be called successively. Grow a string with
    each call to account for this.
  * Add an apport hook for attaching the stderr output when run under
    upstart.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 22 Mar 2012 15:22:51 +0000

whoopsie-daisy (0.1.19) precise; urgency=low

  * Handle errors in parsing the crash database URL.
  * Do not double-free the crash database core submission URL when a
    system UUID is not present (LP: #960972).
  * Handle errors in bson_append_string.
  * Handle more BSON error conditions.
  * Handle empty values in the apport format ("KeyName:\n")
    (LP: #960766, LP: #960737, LP: #960751).

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 21 Mar 2012 17:39:20 +0000

whoopsie-daisy (0.1.18) precise; urgency=low

  * Use https for crash reporting.
  * Ensure we generate core dumps when whoopsie crashes.
  * Do not give whoopsie a shell.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 20 Mar 2012 21:24:51 +0000

whoopsie-daisy (0.1.17) precise; urgency=low

  * Ship a default configuration file.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 16 Mar 2012 14:36:57 +0000

whoopsie-daisy (0.1.16) precise; urgency=low

  * Fix the build of the previous release failing on account of make
    check was failing in the backend code.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 12 Mar 2012 17:45:47 +0000

whoopsie-daisy (0.1.15) precise; urgency=low



=== debian/control ===
Source: whoopsie
Section: utils
Priority: optional
Maintainer: Evan Dandrea <ev@ubuntu.com>
Build-Depends: debhelper (>= 8.0.0),
 libglib2.0-dev (>= 2.31.6),
 libcurl4-openssl-dev,
 libgcrypt11-dev,
 libcap-dev,
 libgtk-3-dev,
 network-manager-dev (>= 0.9.4.0-0ubuntu1),
 python,
 pyflakes,
 dpkg-dev
Standards-Version: 3.9.2
Homepage: http://wiki.ubuntu.com/ErrorTracker
Vcs-Bzr: http://code.launchpad.net/whoopsie

Package: whoopsie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: ${misc:Pre-Depends}
Description: Ubuntu crash database submission daemon
 This program submits crash reports back to an Ubuntu server.

## whoopsie 0.2.5

=== debian/changelog ===
whoopsie (0.2.5) quantal; urgency=low

  * Send the OopsText field so that we can generate a crash signature
    for KernelOops problems. This lets us bucket KernelOops problems
    together so they appear in the 'most common problems' table on
    https://errors.ubuntu.com.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 12 Oct 2012 15:25:22 +0100

whoopsie (0.2.4) quantal; urgency=low

  * Send the Tags field with the report so that we can create a view of
    just crashes of packages installed from $release-proposed.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 11 Oct 2012 14:36:51 +0100

whoopsie (0.2.3) quantal; urgency=low

  * Do not send the kernel core dump (VmCore) with the initial crash
    metadata.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 17 Sep 2012 10:30:19 +0100

whoopsie (0.2.2) quantal; urgency=low

  [ Brian Murray ]
  * Add LiveMediaBuild to acceptable fields (LP: #999816)  

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 29 Aug 2012 10:00:56 +0100

whoopsie (0.2.1) quantal; urgency=low

  * Provide a libwhoopsie library. This allows the control center panel
    via activity-log-manager to provide a 'Show Previous Reports'
    button.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 18 Jun 2012 09:32:46 +0100

## whoopsie 0.2.7.1

=== Makefile ===
VERSION=$(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2)

libwhoopsie_SOURCES=src/identifier.c
libwhoopsie_OBJECTS=$(libwhoopsie_SOURCES:.c=.o)
libwhoopsie_CFLAGS=$(shell pkg-config --cflags glib-2.0) \
				   $(shell libgcrypt-config --cflags) \
				   $(CFLAGS) $(CPPFLAGS)
libwhoopsie_LIBS=$(shell pkg-config --libs glib-2.0) \
				 $(shell libgcrypt-config --libs) \
				 $(LDFLAGS)

whoopsie_CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
	   -g -Ilib -Wall -Werror -Os -DVERSION=\"$(VERSION)\" \
	   $(CFLAGS) $(CPPFLAGS)
whoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
			  $(LDFLAGS)
SOURCES=src/whoopsie.c \
		src/utils.c \
		src/connectivity.c \
		src/monitor.c \
		lib/bson/bson.c \
		lib/bson/encoding.c \
		lib/bson/numbers.c
OBJECTS=$(SOURCES:.c=.o)
EXECUTABLE=src/whoopsie
BIN=$(DESTDIR)/usr/bin
DATA=$(DESTDIR)/etc

.PHONY: all clean check install

all: $(SOURCES) $(EXECUTABLE)

$(libwhoopsie_OBJECTS): $(libwhoopsie_SOURCES)
	$(CC) -std=c99 -fPIC -c $(libwhoopsie_CFLAGS) -o $@ $^

src/libwhoopsie.so.0.0: $(libwhoopsie_OBJECTS)
	$(CC) -std=c99 -shared -Wl,-soname,libwhoopsie.so.0 -o $@ $^ $(libwhoopsie_LIBS)
	ln -sf libwhoopsie.so.0.0 src/libwhoopsie.so.0
	ln -sf libwhoopsie.so.0.0 src/libwhoopsie.so

$(EXECUTABLE): $(OBJECTS) src/libwhoopsie.so.0.0
	$(CC) -std=c99 $(OBJECTS) $(whoopsie_LIBS) -Lsrc -lwhoopsie -o $@
clean:
	rm -f $(EXECUTABLE) $(OBJECTS) $(libwhoopsie_OBJECTS) src/libwhoopsie.so*
	$(MAKE) -C src/tests clean
check:
	$(MAKE) -C src/tests
	if type cppcheck >/dev/null 2>&1; then \
		cppcheck . --error-exitcode=1; \
	fi
	find -name "*.py" -o -name "*.wsgi" | xargs pyflakes
coverage:
	$(MAKE) -C src/tests coverage
%.o: %.c
	$(CC) -std=c99 -c $(whoopsie_CFLAGS) -o $@ $^

install: all
	install -d $(BIN)
	install src/whoopsie $(BIN)
	install -d $(DATA)/init
	install -m644 data/whoopsie.conf $(DATA)/init
	install -d $(DATA)/default
	install -m644 data/whoopsie $(DATA)/default
	install -d $(DESTDIR)/usr/share/apport/package-hooks
	install -m644 data/whoopsie.py $(DESTDIR)/usr/share/apport/package-hooks
	install -d $(DESTDIR)/usr/lib
	install -m644 src/libwhoopsie.so.0.0 $(DESTDIR)/usr/lib
	cp -d src/libwhoopsie.so $(DESTDIR)/usr/lib
	cp -d src/libwhoopsie.so.0 $(DESTDIR)/usr/lib
	install -d $(DESTDIR)/usr/lib/pkgconfig
	install -m644 lib/libwhoopsie.pc $(DESTDIR)/usr/lib/pkgconfig
	install -d $(DESTDIR)/usr/include/libwhoopsie
	install -m644 src/identifier.h $(DESTDIR)/usr/include/libwhoopsie

=== src/tests/Makefile ===
--- 
+++ 
@@ -39,22 +39,22 @@
 	$(foreach p, $^, ./$p -k;)
 
 $(test_parse_report_EXECUTABLE): $(test_parse_report_OBJECTS)
-	c99 $^ $(LIBS) -o $@
+	$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_utils_EXECUTABLE): $(test_utils_OBJECTS)
-	c99 $^ $(LIBS) -o $@
+	$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_monitor_EXECUTABLE): $(test_monitor_OBJECTS)
-	c99 $^ $(LIBS) -o $@
+	$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_identifier_EXECUTABLE): $(test_identifier_OBJECTS)
-	c99 $^ $(LIBS) -o $@
+	$(CC) -std=c99 $^ $(LIBS) -o $@
 
 test_parse_report_coverage: $(test_parse_report_OBJECTS:.test.o=.coverage.o)
-	c99 $^ $(LIBS) -lgcov -o $@
+	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 test_utils_coverage: $(test_utils_OBJECTS:.test.o=.coverage.o)
-	c99 $^ $(LIBS) -lgcov -o $@
+	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 test_monitor_coverage: $(test_monitor_OBJECTS:.test.o=.coverage.o)
-	c99 $^ $(LIBS) -lgcov -o $@
+	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 test_identifier_coverage: $(test_identifier_OBJECTS:.test.o=.coverage.o)
-	c99 $^ $(LIBS) -lgcov -o $@
+	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 coverage: test_parse_report_coverage test_utils_coverage test_monitor_coverage test_identifier_coverage
 	$(foreach p, $^, ./$p -k;)
 	$(foreach p, $(wildcard ../*.c), gcov $p -o $(p:.c=.coverage.o);)
@@ -78,6 +78,6 @@
 		-name '*.gcov' \) -delete
 
 %.coverage.o: %.c
-	c99 -c -o $@ $^ $(CFLAGS) --coverage -O0
+	$(CC) -std=c99 -c -o $@ $^ $(CFLAGS) --coverage -O0
 %.test.o: %.c
-	c99 -c -o $@ $^ $(CFLAGS)
+	$(CC) -std=c99 -c -o $@ $^ $(CFLAGS)

=== debian/changelog ===
whoopsie (0.2.7.1) quantal-proposed; urgency=low

  * Do not modify the .uploaded file corresponding to a .crash file when
    starting up (LP: #1084311)

 -- Brian Murray <brian@ubuntu.com>  Thu, 13 Dec 2012 16:26:40 -0800

whoopsie (0.2.7) quantal-proposed; urgency=low

  * Also include the InstallationMedia field so that we can tie the
    installation date to a release (LP: #1071255).

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 25 Oct 2012 11:46:12 +0100

whoopsie (0.2.6) quantal-proposed; urgency=low

  * Send the UpgradeStatus and InstallationDate fields from apport (LP:
    #1070400).

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 24 Oct 2012 11:05:50 +0100

## whoopsie 0.2.7.2

=== debian/changelog ===
whoopsie (0.2.7.2) quantal-proposed; urgency=low

  * Continue to process the existing crash reports every two hours, not
    just once after two hours (LP: #1205374).

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 29 Jul 2013 17:12:16 +0100

## whoopsie 0.2.13

=== Makefile ===
--- 
+++ 
@@ -9,10 +9,10 @@
 				 $(shell libgcrypt-config --libs) \
 				 $(LDFLAGS)
 
-whoopsie_CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
+whoopsie_CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl libnm-glib) \
 	   -g -Ilib -Wall -Werror -Os -DVERSION=\"$(VERSION)\" \
 	   $(CFLAGS) $(CPPFLAGS)
-whoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
+whoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl libnm-glib) -lcap \
 			  $(LDFLAGS)
 SOURCES=src/whoopsie.c \
 		src/utils.c \
@@ -48,7 +48,8 @@
 	if type cppcheck >/dev/null 2>&1; then \
 		cppcheck . --error-exitcode=1; \
 	fi
-	find -name "*.py" -o -name "*.wsgi" | xargs pyflakes
+	find -name "*.py" | xargs pyflakes
+	@APPORT_REPORT_DIR=$(shell mktemp -d) ./tools/check_valgrind
 coverage:
 	$(MAKE) -C src/tests coverage
 %.o: %.c

=== src/tests/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
-VERSION=$(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2)
-CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
+VERSION=$(shell dpkg-parsechangelog -l../../debian/changelog | grep ^Version: | cut -d' ' -f2)
+CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl libnm-glib) \
 		$(shell libgcrypt-config --cflags) \
 		-g -I../../lib -I.. -DVERSION=\"$(VERSION)\" -DTEST -DTEST_DIR=\"$(CURDIR)\" -Wall
-LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
+LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl libnm-glib) -lcap \
 		$(shell libgcrypt-config --libs)
 
 test_parse_report_SOURCES=test_parse_report.c \

=== debian/changelog ===
whoopsie (0.2.13) raring; urgency=low

  * Do not leak when CURL cannot be initialised. Tear down the directory
    monitors in the test cases. Cast to correct arguments when setting
    up a report processing timeout.
  * Don't try to connect signals to NULL objects.
  * Don't look for reports in /var/crash when running the valgrind
    tests. Makefile
  * Set up /var/crash earlier and with the correct permissions, while we
    still have root.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 12 Feb 2013 15:12:02 +0000

whoopsie (0.2.12) raring; urgency=low

  * g_type_init is deprecated in 2.35/2.36 according to the buildds.
  * Put src/ in the library path when running whoopsie under the
    valgrind test.
  * Fix memory leak when the .upload file does not exist when checking
    to see if a report has already been handled. Thanks Colin Watson.
  * Use glib memory allocation everywhere.
  * Fix a leak if we cannot get the default network monitor.
  * Don't initialise the W32 bits in CURL.
  * Don't initialise curl until we're ready to use it.
  * Actually pass the report directory to process_existing_files at the
    timeout interval.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 05 Feb 2013 17:12:18 +0000

whoopsie (0.2.11) raring; urgency=low

  * Build-depend on valgrind.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 29 Jan 2013 20:23:54 +0000

whoopsie (0.2.10) quantal; urgency=low

  * smatch-detected redundant null check. 'If ptr is NULL, no operation
    is performed.'
  * valgrind-discovered leak in process_existing_files when the crash
    report has already been handled.
  * Clean up after the directory monitor when we're done with it.
  * Stop monitoring for connectivity on shutdown.
  * Use libnm-glib instead of DBus for communicating with
    NetworkManager. This fixes a hard-to-trace memory leak in our usage
    of gvariant.
  * Fix a socket leak found by Coverity.
  * Finally check the mkdir call for the /var/crash directory, now that
    Coverity is complaining about it.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 29 Jan 2013 20:20:04 +0000

whoopsie (0.2.9) raring; urgency=low

  * Do not modify the .uploaded file corresponding to a .crash file when
    starting up (LP: #1084311)

 -- Brian Murray <brian@ubuntu.com>  Tue, 11 Dec 2012 10:16:56 -0800

whoopsie (0.2.8) raring; urgency=low

  * Fix /whoopsie/get-mac-address test. This test previously hardcoded "eth0"
    for comparing the MAC against. eth0 is not guaranteed to exist, and
    whoopsie might use another device instead (such as wlan0).
    Change the test to require that whoopsie_identifier_get_mac_address()
    matches any network device instead.
  * Run as non-root when specifying additional environment variables. We
    mostly need root privileges for determining the system UUID and for
    creating the lock file. When testing, it is often convenient to run this
    with a predictable fake UUID and a temporary report directory, so start
    without root privileges if $CRASH_DB_IDENTIFIER is provided.  Just like
    Apport, also respect $APPORT_REPORT_DIR to use a different report
    directory. If this is given, create the lock file there instead of in
    /var/lock/whoopsie/. 
  * Fix all compiler warnings:
    - Add some missing #includes
    - Fix version parsing in src/tests/Makefile
    - Fix broken function declarations
    - Move non-test code into #ifndef TEST section

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 11 Dec 2012 11:49:49 +0100

=== debian/control ===
Source: whoopsie
Section: utils
Priority: optional
Maintainer: Evan Dandrea <ev@ubuntu.com>
Build-Depends: debhelper (>= 9.0),
 libglib2.0-dev (>= 2.31.6),
 libcurl4-openssl-dev,
 libgcrypt11-dev,
 libcap-dev,
 libgtk-3-dev,
 libnm-glib-dev,
 network-manager-dev (>= 0.9.4.0-0ubuntu1),
 python,
 valgrind,
 pyflakes
Standards-Version: 3.9.3
Homepage: http://wiki.ubuntu.com/ErrorTracker
Vcs-Bzr: http://code.launchpad.net/whoopsie

Package: whoopsie
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 libwhoopsie0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Ubuntu error tracker submission
 This program submits crash reports back to an Ubuntu server.

Package: libwhoopsie0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ubuntu error tracker submission - shared library
 This library provides methods to generate an identifier for use with the
 Ubuntu error tracker

Package: libwhoopsie-dev
Section: libdevel
Architecture: any
Depends: libwhoopsie0 (= ${binary:Version}), ${misc:Depends}
Description: Ubuntu error tracker submission - library development files
 This library provides methods to generate an identifier for use with the
 Ubuntu error tracker

## whoopsie 0.2.13ubuntu1

=== debian/changelog ===
whoopsie (0.2.13ubuntu1) raring; urgency=low

  * Do not start whoopsie if ubiquity presence is detected, as it causes
    failures to install/oem-configure. Regression between 0.2.9 - 0.2.13.
    See http://pad.lv/1123798 for history.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Mon, 18 Feb 2013 16:40:24 +0000

## whoopsie 0.2.15

=== Makefile ===
--- 
+++ 
@@ -9,10 +9,10 @@
 				 $(shell libgcrypt-config --libs) \
 				 $(LDFLAGS)
 
-whoopsie_CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl libnm-glib) \
+whoopsie_CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
 	   -g -Ilib -Wall -Werror -Os -DVERSION=\"$(VERSION)\" \
 	   $(CFLAGS) $(CPPFLAGS)
-whoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl libnm-glib) -lcap \
+whoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
 			  $(LDFLAGS)
 SOURCES=src/whoopsie.c \
 		src/utils.c \

=== debian/changelog ===
whoopsie (0.2.15) raring; urgency=low

  * Bring back old GDBus code to talk to NetworkManager as a workaround
    for LP: #1124330.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 26 Feb 2013 10:51:11 +0000

whoopsie (0.2.14) raring; urgency=low

  * Don't crash when there are no active connections. Thanks Ben
    Collins.

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 20 Feb 2013 18:17:21 +0000

## whoopsie 0.2.15.1

=== src/tests/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 VERSION=$(shell dpkg-parsechangelog -l../../debian/changelog | grep ^Version: | cut -d' ' -f2)
-CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl libnm-glib) \
+CFLAGS=$(shell pkg-config --cflags gio-2.0 glib-2.0 libcurl) \
 		$(shell libgcrypt-config --cflags) \
 		-g -I../../lib -I.. -DVERSION=\"$(VERSION)\" -DTEST -DTEST_DIR=\"$(CURDIR)\" -Wall
-LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl libnm-glib) -lcap \
+LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0 libcurl) -lcap \
 		$(shell libgcrypt-config --libs)
 
 test_parse_report_SOURCES=test_parse_report.c \

=== debian/changelog ===
whoopsie (0.2.15.1) raring-proposed; urgency=low

  * Continue to process the existing crash reports every two hours, not
    just once after two hours (LP: #1205374).

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 26 Jul 2013 16:15:42 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,6 @@
  libgcrypt11-dev,
  libcap-dev,
  libgtk-3-dev,
- libnm-glib-dev,
  network-manager-dev (>= 0.9.4.0-0ubuntu1),
  python,
  valgrind,

## whoopsie 0.2.24.1

=== debian/changelog ===
whoopsie (0.2.24.1) saucy; urgency=low

  * Fix !arm64 build.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 16 Oct 2013 09:53:22 +0100

whoopsie (0.2.24) saucy; urgency=low

  * Do not run valgrind tests, when not available.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 16 Oct 2013 09:40:03 +0100

whoopsie (0.2.23) saucy; urgency=low

  * Don't lower the refcount to 0 on the system bus until shutdown, when
    the application is done using it (LP: #1211417).
  * Clean up calls to g_variant_get. Don't bother sinking the reference
    before calling our own functions.
  * Fix test_get_system_uuid unit test leaking memory.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 16 Aug 2013 14:54:08 +0100

whoopsie (0.2.22) saucy; urgency=low

  * Add an option to assume there is always a route to $CRASH_DB_URL.

 -- Evan Dandrea <ev@ubuntu.com>  Thu, 15 Aug 2013 08:35:13 +0100

whoopsie (0.2.21) saucy; urgency=low

  * Fix logically dead code path. Thanks Coverity (CID 989205).
  * Don't leak a socket if we cannot get the list of network interfaces.
    Thanks Coverity (CID 971184).
  * Avoid a potential null pointer dereference.
  * Always log messages via the logging code, never straight to stdout.

 -- Evan Dandrea <ev@ubuntu.com>  Wed, 14 Aug 2013 14:02:26 +0100

whoopsie (0.2.20) saucy; urgency=low

  * Don't fail if the temporary file in the logging test has already
    gone away.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 12 Aug 2013 09:43:25 +0100

whoopsie (0.2.19) saucy; urgency=low

  * Better handle stat calls in logging test.
  * If APPORT_REPORT_DIR is set to a nul-byte, fall back to the default.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 09 Aug 2013 16:46:20 +0100

whoopsie (0.2.18) saucy; urgency=low

  * Debugging why the buildds cannot remove the temporary files created
    for the logging tests.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 09 Aug 2013 15:57:54 +0100

whoopsie (0.2.17) saucy; urgency=low

  * Log to syslog.

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 09 Aug 2013 11:34:05 +0100

whoopsie (0.2.16) saucy; urgency=low

  * Continue to process the existing crash reports every two hours, not
    just once after two hours (LP: #1205374).

 -- Evan Dandrea <ev@ubuntu.com>  Fri, 26 Jul 2013 16:17:31 +0100

## whoopsie 0.2.24.1.2

=== debian/changelog ===
whoopsie (0.2.24.1.2) saucy; urgency=medium

  * Do not send Stacktrace, and ThreadStacktrace as retracing with ddebs will
    provide more useful versions of them. (LP: #1306175)

 -- Brian Murray <brian@ubuntu.com>  Mon, 14 Apr 2014 14:23:24 -0700

whoopsie (0.2.24.1.1) saucy; urgency=low

  * Close and reopen the log file so that the file descriptor is not closed
    when daemonizing. (LP: #1245524)
  * Move whoopsie starting up message out of open_log so that it is not
    called multiple times when starting whoopsie.
  * Do not close the locking file descriptor when daemonizing.
  * Duplicate the APPORT_REPORT_DIR env as a string so that it is overwritten
    by the next call to g_getenv().
  * Use g_getenv when finding an enviornmental variable.

 -- Brian Murray <brian@ubuntu.com>  Mon, 20 Jan 2014 07:27:32 -0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libgtk-3-dev,
  network-manager-dev (>= 0.9.4.0-0ubuntu1),
  python,
- valgrind,
+ valgrind [!arm64],
  pyflakes
 Standards-Version: 3.9.3
 Homepage: http://wiki.ubuntu.com/ErrorTracker

## whoopsie 0.2.24.5

=== debian/changelog ===
whoopsie (0.2.24.5) trusty; urgency=medium

  * Do not send Stacktrace, and ThreadStacktrace as retracing with ddebs will
    provide more useful versions of them. (LP: #1306175)

 -- Brian Murray <brian@ubuntu.com>  Thu, 10 Apr 2014 10:58:39 -0700

whoopsie (0.2.24.4) trusty; urgency=low

  * Close and reopen the log file so that the file descriptor is not closed
    when daemonizing. (LP: #1245524)

 -- Brian Murray <brian@ubuntu.com>  Tue, 21 Jan 2014 08:23:30 -0800

whoopsie (0.2.24.3) trusty; urgency=medium

  * Don't use valgrind altogether, reporting unrelated leakage.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 20:15:10 +0000

whoopsie (0.2.24.2) trusty; urgency=medium

  * Don't use valgrind on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 18 Dec 2013 17:16:25 +0100

## whoopsie 0.2.24.6ubuntu4

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,7 @@
 		src/utils.c \
 		src/connectivity.c \
 		src/monitor.c \
+		src/logging.c \
 		lib/bson/bson.c \
 		lib/bson/encoding.c \
 		lib/bson/numbers.c
@@ -49,7 +50,9 @@
 		cppcheck . --error-exitcode=1; \
 	fi
 	find -name "*.py" | xargs pyflakes
-	@APPORT_REPORT_DIR=$(shell mktemp -d) ./tools/check_valgrind
+	if type valgrind >/dev/null 2>&1; then \
+		APPORT_REPORT_DIR=$(shell mktemp -d) ./tools/check_valgrind; \
+	fi
 coverage:
 	$(MAKE) -C src/tests coverage
 %.o: %.c

=== src/tests/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 
 test_parse_report_SOURCES=test_parse_report.c \
 							../whoopsie.c \
+							../logging.c \
 							../utils.c \
 							../identifier.c \
 							../../lib/bson/bson.c \
@@ -22,6 +23,7 @@
 
 test_monitor_SOURCES=test_monitor.c \
 					../monitor.c \
+					../logging.c \
 					../utils.c
 test_monitor_EXECUTABLE=test_monitor
 test_monitor_OBJECTS=$(test_monitor_SOURCES:.c=.test.o)
@@ -31,11 +33,16 @@
 test_identifier_EXECUTABLE=test_identifier
 test_identifier_OBJECTS=$(test_identifier_SOURCES:.c=.test.o)
 
+test_logging_SOURCES=test_logging.c \
+					../logging.c
+test_logging_EXECUTABLE=test_logging
+test_logging_OBJECTS=$(test_logging_SOURCES:.c=.test.o)
+
 .PHONY: all clean check
 
 all: check
 
-check: $(test_parse_report_EXECUTABLE) $(test_utils_EXECUTABLE) $(test_monitor_EXECUTABLE) $(test_identifier_EXECUTABLE)
+check: $(test_parse_report_EXECUTABLE) $(test_utils_EXECUTABLE) $(test_monitor_EXECUTABLE) $(test_identifier_EXECUTABLE) $(test_logging_EXECUTABLE)
 	$(foreach p, $^, ./$p -k;)
 
 $(test_parse_report_EXECUTABLE): $(test_parse_report_OBJECTS)
@@ -46,6 +53,8 @@
 	$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_identifier_EXECUTABLE): $(test_identifier_OBJECTS)
 	$(CC) -std=c99 $^ $(LIBS) -o $@
+$(test_logging_EXECUTABLE): $(test_logging_OBJECTS)
+	$(CC) -std=c99 $^ $(LIBS) -o $@
 
 test_parse_report_coverage: $(test_parse_report_OBJECTS:.test.o=.coverage.o)
 	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
@@ -55,7 +64,9 @@
 	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 test_identifier_coverage: $(test_identifier_OBJECTS:.test.o=.coverage.o)
 	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
-coverage: test_parse_report_coverage test_utils_coverage test_monitor_coverage test_identifier_coverage
+test_logging_coverage: $(test_logging_OBJECTS:.test.o=.coverage.o)
+	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
+coverage: test_parse_report_coverage test_utils_coverage test_monitor_coverage test_identifier_coverage test_logging_coverage
 	$(foreach p, $^, ./$p -k;)
 	$(foreach p, $(wildcard ../*.c), gcov $p -o $(p:.c=.coverage.o);)
 
@@ -68,9 +79,11 @@
 		$(test_monitor_EXECUTABLE) \
 		$(test_identifier_OBJECTS) \
 		$(test_identifier_EXECUTABLE) \
+		$(test_logging_EXECUTABLE) \
 		test_parse_report_coverage \
 		test_utils_coverage \
 		test_identifier_coverage \
+		test_logging_coverage \
 		coverage
 	find ../.. \( -name '*.coverage.o' -o \
 		-name '*.gcda' -o \

=== debian/changelog ===
whoopsie (0.2.24.6ubuntu4) trusty-proposed; urgency=medium

  * src/whoopsie.c: Add ProcCpuinfoMinimal which can be larger than 1KB to the
    list of accepted fields. (LP: #1673557)

 -- Brian Murray <brian@ubuntu.com>  Fri, 12 May 2017 10:25:00 -0700

whoopsie (0.2.24.6ubuntu3) trusty-proposed; urgency=medium

  * Allow uploading of any field with data less than 1KB, creating a whitelist
    of fields with large data, and a blacklist of fields we don't want in the
    Error Tracker. (LP: #1616559)
  * src/whoopsie.c: Add fields from package management applications that can
    be larger than 1KB to the list of accepted fields. (LP: #1616517)

 -- Brian Murray <brian@ubuntu.com>  Tue, 23 Aug 2016 17:17:02 -0700

whoopsie (0.2.24.6ubuntu2) trusty-proposed; urgency=medium

  * src/whoopsie.c: Send UnreportableReason to the Error Tracker that way we
    know apport's opinion of the crash. (LP: #1382233)

 -- Brian Murray <brian@ubuntu.com>  Mon, 09 Nov 2015 13:24:00 -0800

whoopsie (0.2.24.6ubuntu1) trusty-proposed; urgency=medium

  * Merge patch from Bryan Quigley to only log when whoopsie's state changes.
    (LP: #1217407)

 -- Brian Murray <brian@ubuntu.com>  Mon, 02 Feb 2015 14:28:08 -0800

whoopsie (0.2.24.6) trusty-proposed; urgency=medium

  * Log the OOPS ID (returned by daisy) for the reported crash. (LP: #1326000)

 -- Brian Murray <brian@ubuntu.com>  Mon, 09 Jun 2014 11:03:32 -0700

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  libgtk-3-dev,
  network-manager-dev (>= 0.9.4.0-0ubuntu1),
  python,
- valgrind [!arm64],
  pyflakes
 Standards-Version: 3.9.3
 Homepage: http://wiki.ubuntu.com/ErrorTracker

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DESTDIR=$(CURDIR)/debian/whoopsie

%:
	dh $@ 

override_dh_installinit:
	dh_installinit -pwhoopsie -o --upstart-only

## whoopsie 0.2.39

=== debian/changelog ===
whoopsie (0.2.39) utopic; urgency=medium

  * Use G_SOURCE_CONTINUE and G_SOURCE_REMOVE for GSourceFunc return values,
    for clarity
  * tests/monitor: Call g_main_loop_quit from a callback function which
    removes the source instead of directly. GSourceFuncs need to return a
    boolean to say if they should be executed again or not. (LP: #1381804)

 -- Iain Lane <iain.lane@canonical.com>  Thu, 16 Oct 2014 10:32:22 +0100

whoopsie (0.2.38) utopic; urgency=medium

  [ Evan Dandrea ]
  * Run all the tests, then exit on failure.

  [ Brian Murray ]
  * Add _MarkForUpload field to the blacklist as it is redundant.
  * Make whoopsie_identifier_generate() stable throughout the system boot.
    Thanks Dimitri. (LP: #1339916)
  * Temporarily disable test_identifier test as it has never worked when
    building the package.
  * Create /var/lib/whoopsie and store the identifier there in whoopsie-id.

 -- Brian Murray <brian@ubuntu.com>  Thu, 09 Oct 2014 15:58:48 -0700

whoopsie (0.2.37) utopic; urgency=medium

  [ Evan Dandrea ]
  * Attempt to use the android serial number before falling back to the
    system UUID. Thanks Dimitri.
  * Log in more parts of the connectivity check.
  * Provide timestamps when logging to the foreground.

  [ Brian Murray ]
  * Merge Ted's branch that allows uploading of any field with data less than
    1KB, creating a whitelist of fields with large data, and a blacklist of
    fields we don't want in the error tracker.
  * Fix bug in how timestamps are provided.

 -- Brian Murray <brian@ubuntu.com>  Thu, 28 Aug 2014 15:25:15 -0700

whoopsie (0.2.36) utopic; urgency=medium

  * In the apport package hook switch from searching syslog for whoopsie
    messages and instead upload /var/log/upstart/whoopsie.log.
  * src/whoopsie.c: include SystemImageInfo in the data uploaded to errors.

 -- Brian Murray <brian@ubuntu.com>  Tue, 29 Jul 2014 13:49:36 -0700

whoopsie (0.2.35) utopic; urgency=medium

  [ Brian Murray ]
  * Add a space before the autoreport tag in bug reports.

  [ Martin Pitt ]
  * data/whoopsie.conf: Start whoopsie in the foreground and drop the "expect
    fork". This provides proper logging to /var/log/upstart/, simplifies
    things for upstart, and also curiously seems to cause crash reports to now
    actually get picked up and uploaded. (LP: #1340604)
  * debian/control: Fix Vcs-* tags to make debcheckout actually work.
  * Bump Standards-Version to 3.9.5 (no changes necessary).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 24 Jul 2014 14:36:06 +0200

whoopsie (0.2.34) utopic; urgency=medium

  [ John Lenton ]
  * Obtain a MAC address for system identifier generation even if the network
    is not up. (LP: #1328285)

 -- Brian Murray <brian@ubuntu.com>  Mon, 07 Jul 2014 11:44:26 -0700

whoopsie (0.2.33) utopic; urgency=medium

  * Log the OOPS ID (returned by daisy) in another case.

 -- Brian Murray <brian@ubuntu.com>  Thu, 26 Jun 2014 09:10:28 -0700

whoopsie (0.2.32) utopic; urgency=medium

  * Gather autoreport and apport-noui information in the package hook. Also
    check syslog for information from whoopsie.

 -- Brian Murray <brian@ubuntu.com>  Mon, 23 Jun 2014 09:44:20 -0700

whoopsie (0.2.31) utopic; urgency=medium

  * Log the OOPS ID (returned by daisy) for the reported crash. (LP: #1326000)

 -- Brian Murray <brian@ubuntu.com>  Mon, 09 Jun 2014 10:49:55 -0700

whoopsie (0.2.30) utopic; urgency=medium

  * Clean up src/tests/test_logging.test.o.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 02 Jun 2014 17:42:27 +0100

whoopsie (0.2.29) utopic; urgency=medium

  [ John Lenton ]
  * Depend on gio in libwhoopsie.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 02 Jun 2014 14:56:25 +0100

whoopsie (0.2.28) utopic; urgency=medium

  * Fix FTBFS.

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 02 Jun 2014 11:19:57 +0100

whoopsie (0.2.27) utopic; urgency=medium

  [ Brian Murray ]
  * Log that we are offline because we are using a network connection where
    one may have to pay for data usage.

  [ John Lenton ]
  * Ask ofono for the IMEI as an id source.
  * Don't return null string during session start (LP: #1311571).
  * Fix attempting to remove a source that has already been removed.

  [ Ted Gould ]
  * Don't break if whoopsie is running (i.e. developer system).

 -- Evan Dandrea <ev@ubuntu.com>  Mon, 02 Jun 2014 11:10:40 +0100

whoopsie (0.2.26) utopic; urgency=medium

  * Add systemd unit. (LP: #1314413)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 12 May 2014 10:04:10 +0200

whoopsie (0.2.25) utopic; urgency=medium

  * Collect iwl firmware debugging dumps.

 -- Evan Dandrea <ev@ubuntu.com>  Tue, 29 Apr 2014 12:00:21 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Evan Dandrea <ev@ubuntu.com>
 Build-Depends: debhelper (>= 9.0),
- libglib2.0-dev (>= 2.31.6),
+ dh-systemd,
+ libglib2.0-dev (>= 2.32),
  libcurl4-openssl-dev,
  libgcrypt11-dev,
  libcap-dev,
@@ -11,9 +12,10 @@
  network-manager-dev (>= 0.9.4.0-0ubuntu1),
  python,
  pyflakes
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://wiki.ubuntu.com/ErrorTracker
-Vcs-Bzr: http://code.launchpad.net/whoopsie
+Vcs-Bzr: lp:whoopsie
+Vcs-Browser: http://bazaar.launchpad.net/~daisy-pluckers/whoopsie/trunk/
 
 Package: whoopsie
 Architecture: any

## whoopsie 0.2.39ubuntu0.2

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 libwhoopsie_CFLAGS=$(shell pkg-config --cflags glib-2.0) \
 				   $(shell libgcrypt-config --cflags) \
 				   $(CFLAGS) $(CPPFLAGS)
-libwhoopsie_LIBS=$(shell pkg-config --libs glib-2.0) \
+libwhoopsie_LIBS=$(shell pkg-config --libs gio-2.0 glib-2.0) \
 				 $(shell libgcrypt-config --libs) \
 				 $(LDFLAGS)
 
@@ -62,7 +62,9 @@
 	install -d $(BIN)
 	install src/whoopsie $(BIN)
 	install -d $(DATA)/init
+	install -d $(DESTDIR)/lib/systemd/system
 	install -m644 data/whoopsie.conf $(DATA)/init
+	install -m644 data/whoopsie.service $(DESTDIR)/lib/systemd/system
 	install -d $(DATA)/default
 	install -m644 data/whoopsie $(DATA)/default
 	install -d $(DESTDIR)/usr/share/apport/package-hooks

=== src/tests/Makefile ===
--- 
+++ 
@@ -28,10 +28,10 @@
 test_monitor_EXECUTABLE=test_monitor
 test_monitor_OBJECTS=$(test_monitor_SOURCES:.c=.test.o)
 
-test_identifier_SOURCES=test_identifier.c \
+#test_identifier_SOURCES=test_identifier.c \
 					../identifier.c
-test_identifier_EXECUTABLE=test_identifier
-test_identifier_OBJECTS=$(test_identifier_SOURCES:.c=.test.o)
+#test_identifier_EXECUTABLE=test_identifier
+#test_identifier_OBJECTS=$(test_identifier_SOURCES:.c=.test.o)
 
 test_logging_SOURCES=test_logging.c \
 					../logging.c
@@ -42,8 +42,11 @@
 
 all: check
 
-check: $(test_parse_report_EXECUTABLE) $(test_utils_EXECUTABLE) $(test_monitor_EXECUTABLE) $(test_identifier_EXECUTABLE) $(test_logging_EXECUTABLE)
-	$(foreach p, $^, ./$p -k;)
+check: $(test_parse_report_EXECUTABLE) $(test_utils_EXECUTABLE) $(test_monitor_EXECUTABLE) $(test_logging_EXECUTABLE)
+	@r=0; for t in $^; do \
+		./$$t -k || r=1; \
+	done; \
+	exit $$r;
 
 $(test_parse_report_EXECUTABLE): $(test_parse_report_OBJECTS)
 	$(CC) -std=c99 $^ $(LIBS) -o $@
@@ -51,8 +54,8 @@
 	$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_monitor_EXECUTABLE): $(test_monitor_OBJECTS)
 	$(CC) -std=c99 $^ $(LIBS) -o $@
-$(test_identifier_EXECUTABLE): $(test_identifier_OBJECTS)
-	$(CC) -std=c99 $^ $(LIBS) -o $@
+#$(test_identifier_EXECUTABLE): $(test_identifier_OBJECTS)
+	#$(CC) -std=c99 $^ $(LIBS) -o $@
 $(test_logging_EXECUTABLE): $(test_logging_OBJECTS)
 	$(CC) -std=c99 $^ $(LIBS) -o $@
 
@@ -67,7 +70,10 @@
 test_logging_coverage: $(test_logging_OBJECTS:.test.o=.coverage.o)
 	$(CC) -std=c99 $^ $(LIBS) -lgcov -o $@
 coverage: test_parse_report_coverage test_utils_coverage test_monitor_coverage test_identifier_coverage test_logging_coverage
-	$(foreach p, $^, ./$p -k;)
+	@r=0; for t in $^; do \
+		./$$t -k || r=1; \
+	done; \
+	exit $$r;
 	$(foreach p, $(wildcard ../*.c), gcov $p -o $(p:.c=.coverage.o);)
 
 clean:
@@ -80,6 +86,7 @@
 		$(test_identifier_OBJECTS) \
 		$(test_identifier_EXECUTABLE) \
 		$(test_logging_EXECUTABLE) \
+		$(test_logging_OBJECTS) \
 		test_parse_report_coverage \
 		test_utils_coverage \
 		test_identifier_coverage \

=== debian/changelog ===
whoopsie (0.2.39ubuntu0.2) utopic-proposed; urgency=medium

  * Merge patch from Bryan Quigley to only log when whoopsie's state changes.
    (LP: #1217407)

 -- Brian Murray <brian@ubuntu.com>  Mon, 02 Feb 2015 14:18:29 -0800

whoopsie (0.2.39ubuntu0.1) utopic-proposed; urgency=medium

  * Change ownership of whoopsie-id so that it is not world readable.
    (LP: #1386752)

 -- Brian Murray <brian@ubuntu.com>  Wed, 29 Oct 2014 12:26:29 -0700

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,9 @@
 export DESTDIR=$(CURDIR)/debian/whoopsie
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_installinit:
+	dh_systemd_enable
 	dh_installinit -pwhoopsie -o --upstart-only
+	dh_systemd_start
